# int arrot(int x, int min, int max) {
#     if (x < media(min,max)) return min;
#     return max;
# }

.globl arrot

arrot:
    pushl %edi
    pushl %esi
    pushl %ebx
    subl $8, %esp        # prologo

    # carica parametri
    movl 24(%esp), %ebx  # ebx = x
    movl 28(%esp), %edi  # edi = min
    movl 32(%esp), %esi  # esi = max

    # chiamata a media
    movl %edi, (%esp)    # passaggio primo parametro
    movl %esi, 4(%esp)   # passaggio secondo parametro
    call media           # chiamata - risultato in eax

    cmpl %eax, %ebx      # x ? media(min,max)
    cmovll %edi, %eax    # if <  then return min
    cmovgel %esi, %eax   # if >= then return max

    addl $8, %esp        # epilogo
    popl %ebx
    popl %esi
    popl %edi
    ret
